% aide: Creating Stream Particle Animations
clear all
load wind
[sx sy sz] = meshgrid(100,20:2:50,5);

verts = stream3(x,y,z,u,v,w,sx,sy,sz);
sl = streamline(verts);

view(-10.5,18)
daspect([2 2 0.125])
axis tight; box on

iverts = interpstreamspeed(x,y,z,u,v,w,verts,0.05);
set(gca,'drawmode','fast');
streamparticles(iverts,15,...
    'Animate',10,...
    'ParticleAlignment','on',...
    'MarkerEdgeColor','none',...
    'MarkerFaceColor','red',...
    'Marker','o');
%===========================================
%aide : animation / Example - Visualizing an FFT as a Movie
clear all
close all
% Create the movie
for k = 1:16
    plot(fft(eye(k+16)))
    axis equal
    M(k) = getframe;
end
% After generating the movie, you can play it back any number of times. To play it back 5 times, type
movie(M,5)

h = uicontrol('style','slider','position',...
    [10 50 20 300],'Min',1,'Max',16,'Value',1)
for k = 1:16
    plot(fft(eye(k+16)))
    axis equal
    set(h,'Value',k)
    M(k) = getframe(gcf);
end

clf
axes('Position',[0 0 1 1])
movie(M,5)
%===========================================
% Exporting MATLAB Graphs in AVI Format
clear all
close all
aviobj = avifile('mymovie.avi','fps',5); 
for k=1:25
    h = plot(fft(eye(k+16)));
    set(h,'EraseMode','xor');
    axis equal;
    frame = getframe(gca);
    aviobj = addframe(aviobj,frame);
end
aviobj = close(aviobj);