% Carte de champ anime
% Grard Tayeb, 12/2005
%=================================================================
% Par trac de la carte au moyen d'une fonction f(x,y,t)
clear all;
xmin = 0.5; xmax = 2; nbrex = 50; x = linspace(xmin,xmax,nbrex);
ymin = 0; ymax = 15; nbrey = 100; y = linspace(ymin,ymax,nbrey);

tmin=0; tmax=1;
nbret=30
dt=(tmax-tmin)/nbret
t = linspace(tmin,tmax-dt,nbret)

for k=1:nbret
    for j= 1:nbrex
        for i = 1:nbrey
            % c'est la qu'il faut faire attention  l'ordre
            ff2(i,j) = fct3( x(j), y(i) , t(k));
        end
    end
    pcolor(x,y,ff2)
    shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
    colorbar
    M(k) = getframe;
end

movie(M,50,50) % movie(nom, nbre rptitions, frames/s)

%=================================================================
% Essais de colormaps
clear all;
xmin = 0.5; xmax = 2; nbrex = 50; x = linspace(xmin,xmax,nbrex);
ymin = 0; ymax = 15; nbrey = 100; y = linspace(ymin,ymax,nbrey);

tmin=0; tmax=1; 
nbret=1;
dt=(tmax-tmin)/nbret
t = linspace(tmin,tmax-dt,nbret)

for k=1:nbret
    for j= 1:nbrex
        for i = 1:nbrey
            % c'est la qu'il faut faire attention  l'ordre
            ff2(i,j) = fct3( x(j), y(i) , t(k));
        end
    end
    pcolor(x,y,ff2)
    shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
    colorbar
end

% On teste une autre colormap (bone):
figure
colormap(bone)
pcolor(x,y,ff2)
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
colorbar

% On lit un fichier
figure
load -ascii colormap_bleu_noir_rouge
colormap(colormap_bleu_noir_rouge)
pcolor(x,y,ff2)
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
colorbar

%=================================================================
% Par lecture d'un fichier associ  une carte de champ complexe
clear all;
% load -ascii champ_guide7b_41
% champ = champ_guide7b_41
load -ascii champ_guide7b_101
champ = champ_guide7b_101

x = unique(champ(:,1))
y = unique(champ(:,2))
nx=length(x)
ny=length(y)
z=reshape(champ(:,5),ny,[])
pcolor(x,y,z)
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
axis square
caxis([0 2]); colorbar;

% Idem avec interpolation bilinear :
figure
[xi,yi] = meshgrid(-40:0.5:60,-50:0.5:50);
zi = interp2(x,y,z,xi,yi);
pcolor(xi,yi,zi)
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
axis square
caxis([0 2]); colorbar;

%=================================================================
% Modifications du script prcdent pour faire une animation
clear all;
load -ascii champ_guide7b_101;
champ = champ_guide7b_101

x = unique(champ(:,1));
y = unique(champ(:,2));
nx=length(x);
ny=length(y);

tmin=0; tmax=1; 
nbret=30; 
dt=(tmax-tmin)/nbret; 
t = linspace(tmin,tmax-dt,nbret);

for k=1:nbret
    cc1=exp(-i*2*pi*t(k));
    u = champ(:,3) + i*champ(:,4); % si champ lu en Re et Im
    %u = champ(:,3) .* exp(i*champ(:,4)*pi/180); % si champ en module et phase (degres)
    reU = real( u * cc1);
    z=reshape(reU,ny,[]);
    pcolor(x,y,z);
    shading interp; % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
    axis square;
    caxis([0 2]); colorbar;
    M(k) = getframe;
end
movie(M,50,10) % movie(nom, nbre rptitions, frames/s)

%=================================================================
% Trac d'une carte de champ complexe  partir d'une fonction
% Exemple pour H0 (Hankel 0):
clear all;
xmin = -10; xmax = 10; nbrex = 51; x = linspace(xmin,xmax,nbrex);
ymin = -10; ymax = 10; nbrey = 51; y = linspace(ymin,ymax,nbrey);

fid = fopen('H0tab','w');
for j= 1:nbrex
    for i = 1:nbrey
        champ(i,j) = besselh(0,1,sqrt(x(j)^2+y(i)^2));
        ligne(1)=x(j);
        ligne(2)=y(i);
        ligne(3)=real(champ(i,j));
        ligne(4)=imag(champ(i,j));
        count = fprintf(fid,'%13.6g %13.6g %13.6g %13.6g\n',ligne);
    end
end
fclose(fid)
%=================================================================
% Transformation de la carte de champ prcdente en movie
clear all;
load -ascii H0tab;
champ = H0tab;

x = unique(champ(:,1)); xmin = min(x); xmax = max(x); nx=length(x); dx = (xmax-xmin)/(nx-1);
y = unique(champ(:,2)); ymin = min(y); ymax = max(y); ny=length(y); dy = (ymax-ymin)/(ny-1);

tmin = 0; tmax = 1; nbret = 30;
% nbret = 30 et 10 frames/s => un peu saccad 
% nbret = 50 et 20 frames/s => fluide 
dt=(tmax-tmin)/nbret; 
t = linspace(tmin,tmax-dt,nbret);

% figure('Position',[400, 0, 1000, 1000]) % pour la faire plus grande que la valeur par dfaut

% chargement d'une colormap:
% load -ascii colormap_bleu_noir_rouge
load -ascii colormap_03
colormap(colormap_03)

for k=1:nbret
    cc1=exp(-i*2*pi*t(k));
    u = champ(:,3) + i*champ(:,4); % si champ lu en Re et Im
    %u = champ(:,3) .* exp(i*champ(:,4)*pi/180); % si champ en module et phase (degres)
    reU = real( u * cc1);
    z=reshape(reU,ny,[]);
    % Au lieu d'utiliser pcolor(x,y,z), on interpole sur un pas deux fois plus fin
    [xi,yi] = meshgrid(xmin:dx/2:xmax,ymin:dy/2:ymax);
    zi = interp2(x,y,z,xi,yi);
    pcolor(xi,yi,zi)
    shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
    axis square
    caxis([-0.5 0.5]); colorbar;
    M(k) = getframe;
end

mov = movie(M,50,10) % movie(nom, nbre rptitions, frames/s)
movie2avi(M,'filmH0','compression','None')

%=================================================================
% Modifications pour faire une animation avec interpolation et position des tiges
clear all;
load -ascii champ_guide7b_101x121;
champ = champ_guide7b_101x121;

x = unique(champ(:,1)); xmin = min(x); xmax = max(x); nx=length(x); dx = (xmax-xmin)/(nx-1);
y = unique(champ(:,2)); ymin = min(y); ymax = max(y); ny=length(y); dy = (ymax-ymin)/(ny-1);

tmin = 0; tmax = 1; nbret = 30;
% nbret = 30 et 10 frames/s => un peu saccad 
% nbret = 50 et 20 frames/s => fluide 
dt=(tmax-tmin)/nbret; 
t = linspace(tmin,tmax-dt,nbret);

% figure('Position',[400, 0, 1000, 1000]) % pour la faire plus grande que la valeur par dfaut

% Position des tiges
load -ascii guide7b25_tiges;
xc = guide7b25_tiges(:,2);
yc = guide7b25_tiges(:,3);
ray = guide7b25_tiges(:,9); dia = 2*ray;
nt=length(xc);

% chargement d'une colormap:
% load -ascii colormap_bleu_noir_rouge
load -ascii colormap_03
colormap(colormap_03)

for k=1:nbret
    cc1=exp(-i*2*pi*t(k));
    u = champ(:,3) + i*champ(:,4); % si champ lu en Re et Im
    %u = champ(:,3) .* exp(i*champ(:,4)*pi/180); % si champ en module et phase (degres)
    reU = real( u * cc1);
    z=reshape(reU,ny,[]);
    % Au lieu d'utiliser pcolor(x,y,z), on interpole sur un pas deux fois plus fin
    [xi,yi] = meshgrid(xmin:dx/2:xmax,ymin:dy/2:ymax);
    zi = interp2(x,y,z,xi,yi);
    pcolor(xi,yi,zi)
    shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
    axis square
    caxis([-2 2]); colorbar;
    % Ajout des tiges
    for it=1:nt
        rectangle('Position',[xc(it)-ray(it),yc(it)-ray(it),dia(it),dia(it)],'Curvature',[1,1],'EdgeColor','y','LineWidth',1,'FaceColor','y')
    end
    M(k) = getframe;
end

mov = movie(M,1,10) % movie(nom, nbre rptitions, frames/s)
movie2avi(M,'filmGT2','compression','None')

% En rsum:
% movie2avi(M,'filmGT2','compression','None')
% puis j'ai utilis VirtalDub pour compresser le prcdent en "Cinepack".
% Toujours avec VirtualDub,
% - on peut aussi compresser en Xvid, qui donne des fichiers plus petits,
% - a marche aussi vers DivX.

%=================================================================
% essais de reshape
A = [1 4 7 10;2 5 8 11;3 6 9 12]
B = reshape(A,2,6)
C = reshape(A,2,[])
D = reshape(A,3,[])
E = reshape(A,4,[])
F = reshape(A,[],3)

% essai d'interpolation
clear all;
[X,Y] = meshgrid(-3:.25:3);
Z = peaks(X,Y);
[XI,YI] = meshgrid(-3:.125:3);
ZI = interp2(X,Y,Z,XI,YI);
mesh(X,Y,Z), hold, mesh(XI,YI,ZI+15)
hold off
axis([-3 3 -3 3 -5 20])
%=================================================================

